
typedef struct {
	u16 size;	//header+data
	u16 type;	//=STATESAVE or SRAMSAVE
	u32 compressedsize;
	u32 framecount;
	u32 checksum;
	char title[32];
} stateheader;

typedef struct {		//(modified stateheader)
	u16 size;
	u16 type;	//=CONFIGSAVE
	char displaytype;
	char misc;
	char misc2;
	char reserved3;
	u32 sram_checksum;	//checksum of rom using SRAM e000-ffff	
	u32 zero;	//=0
	char reserved4[32];  //="CFG"
} configdata;

extern int max_multiboot_size;
extern u8 Image$$RO$$Limit;
extern u8 END_OF_EXRAM;

// Assume a state size of 23K
#define STATESIZE (23*1024)
#define CHEATSIZE (900) // 50 cheats at 18 bytes each
#define SRAMSIZE (0x2000) //8K
#define WORKSPACESIZE (0x10000) //64K

#define OVERHEAD(x) ((x/64+16+4+sizeof(stateheader)+3)&~3)
#define WORSTCASE(x) (x+OVERHEAD(x))
#define WORSTCASEC(x) (x+OVERHEAD(x)+((x<0xbfff)?(x):0xbfff))

//we have a big chunk of memory starting at Image$$RO$$Limit free to use
//Lots of overlapping here
#define RAMEND (&END_OF_EXRAM)
#define WORKSPACE (RAMEND-WORKSPACESIZE)
#define COMPRESSEDSTATE (WORKSPACE-WORSTCASEC(STATESIZE))
// Neither of these pointers overlap the 128KB of LOCALROM
#define COMPRESSEDSRAM (WORKSPACE-WORSTCASEC(SRAMSIZE))
#define COMPRESSEDCHEAT (WORKSPACE-WORSTCASEC(CHEATSIZE))

#define RAWSTATE (WORKSPACE-STATESIZE)
#define RAWSRAM (WORKSPACE-SRAMSIZE)
#define RAWCHEAT (WORKSPACE-CHEATSIZE)
#define RAWCONFIG (WORKSPACE-sizeof(configdata))
//#define ROMHEADER_LOCALROM (&Image$$RO$$Limit+WORSTCASE)
#define LOCALROM ((u8 *) ((((int) &Image$$RO$$Limit)+3)&~3))
